<template>
  <div class="container text-center mt-3">
    <h1>Reaction Timer</h1>
    <div class="d-flex justify-content-between mt-2">
      <h4>Average {{ avgScore }}ms</h4>
      <h4>Counter: {{ counter }}</h4>
    </div>
    <div>
      <button class="btn btn-primary" type="button" @click="toggleSettings">
        {{ showSettings ? 'Hide' : 'Show' }} settings
      </button>
    </div>

    <div class="d-flex justify-content-between flex-wrap mt-3" v-if="showSettings">
      <div class="card card-body">
        <div>
          <p>Size of target: {{ size }}</p>
          <input
            class="form-range"
            type="range"
            min="20"
            max="200"
            v-model="size"
            step="5"
            :disabled="isPlaying"
          />
        </div>
        <div>
          <p>Radius of target (in percentage): {{ radius }}</p>
          <input
            class="form-range"
            type="range"
            min="1"
            max="100"
            v-model="radius"
            step="1"
            :disabled="isPlaying"
          />
        </div>
        <div>
          <p>How many iterations: {{ count }}</p>
          <input
            class="form-range"
            type="range"
            min="5"
            max="20"
            v-model="count"
            step="1"
            :disabled="isPlaying"
          />
        </div>
      </div>
    </div>

    <button v-if="!isPlaying" @click="startGame" class="btn btn-success mt-3">
      Play Game
    </button>
    <button v-else class="btn btn-danger mt-3" @click="stop">Stop</button>
    <reaction-timer
      :key="counter"
      @clicked="boxClicked"
      :isPlaying="isPlaying"
      :stopTimer="stopTimer"
      :size="size"
      :radius="radius"
    />
  </div>
</template>

<script>
import ReactionTimer from './components/ReactionTimer.vue';
export default {
  name: 'App',
  components: {
    ReactionTimer,
  },
  data() {
    return {
      isPlaying: false,
      score: 0,
      marginLeft: 0,
      marginTop: 0,
      counter: 0,
      stopTimer: false,
      size: 150,
      radius: 10,
      count: 15,
      showSettings: true,
    };
  },
  methods: {
    boxClicked(reactionTime) {
      this.score += reactionTime;
      this.counter += 1;
      if (this.counter >= this.count) {
        this.stop();
      }
    },
    stop() {
      this.stopTimer = true;
      this.isPlaying = false;
    },
    startGame() {
      this.isPlaying = true;
      this.score = 0;
      this.counter = 0;
      this.showSettings = false;
    },
    toggleSettings() {
      this.showSettings = !this.showSettings;
    },
  },
  computed: {
    avgScore() {
      const avg = this.score / this.counter;
      return isNaN(avg) ? 0 : Math.round(avg * 100) / 100;
    },
  },
  mounted() {
    if (localStorage.radius) this.radius = localStorage.radius;
    if (localStorage.size) this.size = localStorage.size;
    if (localStorage.count) this.count = localStorage.count;
  },
  watch: {
    radius(newRadius) {
      localStorage.radius = newRadius;
    },
    size(newSize) {
      localStorage.size = newSize;
    },
    count(newCount) {
      localStorage.count = newCount;
    },
  },
};
</script>
